;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Fire Magi Koopa
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			Tile =		$99

			dcb "INIT"
			RTL
			LDA $7FAB9E,x
			STA $00
			TXY
			LDX #$09
CheckSprite:		CPX $15E9
			BEQ NextSprite
			LDA $14C8,x
			BEQ NextSprite
			LDA $7FAB9E,x
			CMP $00
			BNE NextSprite
			LDA #$00
			STA $14C8,y
			TYX
			RTL
NextSprite:		DEX
			BPL CheckSprite
			STZ $18BF
			TYX
			RTL

			dcb "MAIN"
			PHB
			PHK
			PLB
			LDA $9E,x
			PHA
			LDA #$1F
			STA $9E,x
			JSR MainCode
			PLA
			STA $9E,x
			LDX $15E9
			LDA $14C8,x
			BEQ ReturnL
			CMP #$05
			BCS ReturnL
			LDA $14C8,x
			STA $1FD6,x
			LDA #$08
			STA $14C8,x
ReturnL:		PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MainCode:		LDA $1FD6,x
			BEQ LabelFF
			BMI SprWait
			CMP #$02
			BEQ SprKilled
			CMP #$04
			BEQ SprSpinJump
LabelFF:		LDA #$01
			STA $15D0,x
			LDA $15A0,x
			BEQ Label00
			STZ $C2,x
Label00:		LDA $C2,x
			AND #$03
			JSL $0086DF

States:			dcw State0&$FFFF,State1&$FFFF,State2&$FFFF,State3&$FFFF

SprWait:		LDA $14
			AND #$03
			BEQ Return8
			DEC $1626,x
			BNE Return8
			STZ $1FD6,x
			LDA #$7F
			AND $15F6,x
			STA $15F6,x
			LDA #$7F
			AND $1686,x
			STA $1686,x
			STZ $C2,x
Return8:		RTS

SprKilled:		LDA $1686,x
			ORA #$80
			STA $1686,x
			LDA $9D
			BNE LabelA0
			JSL $01802A
LabelA0:		JSR SUB_OFF_SCREEN_X0
			LDA $15F6,x
			ORA #$80
			STA $15F6,x
			STZ $1602,x
			JSL $019D5F		;SubSprGfx1
			RTS

SprSpinJump:		LDA #$FF
			STA $1626,x
			STA $1FD6,x
			RTS

State0:			LDA $18BF
			BEQ Label10
			STZ $14C8,x
			RTS

Label10:		LDA $9D
			BNE Return0
			LDY #$24
			STY $40
			LDA $1540,x
			BNE Return0
			JSL $01ACF9
			CMP #$D1
			BCS Return0
			;CLC
			ADC $1C
			AND #$F0
			STA $D8,x
			LDA $1D
			ADC #$00
			STA $14D4,x
			JSL $01ACF9
			CLC
			ADC $1A
			AND #$F0
			STA $E4,x
			LDA $1B
			ADC #$00
			STA $14E0,x
			JSR SUB_HORZ_POS
			LDA $0F
			CLC
			ADC #$20
			CMP #$40
			BCC Return0
			STZ $AA,x
			LDA #$01
			STA $B6,x
			JSL $019138
			LDA $1588,x
			AND #$04
			BEQ Return0
			LDA $1862
			BNE Return0
			INC $C2,x
			STZ $1570,x
			JSR S_Label0
			JSR SUB_HORZ_POS
			TYA
			STA $157C,x
Return0:		RTS

Table00:		dcb $04,$02,$00
X_Offset:		dcb $10,$F8

State2:			STZ $15D0,x
			JSL $01803A
			JSR SUB_HORZ_POS
			TYA
			STA $157C,x
			LDA $1540,x
			BNE Label08
			INC $C2,x
S_Label0:		LDY #$34
			STY $40
Label08:		CMP #$40
			BNE Label1F
			PHA
			LDA $9D
			ORA $15A0,x
			BNE Label11
			JSR S_Label1
Label11:		PLA
Label1F:		LSR A
			LSR A
			LSR A
			LSR A
			LSR A
			LSR A
			TAY
			PHY
			LDA $1540,x
			LSR A
			LSR A
			LSR A
			AND #$01
			ORA Table00,y
			STA $1602,x
			JSL $019D5F		;SubSprGfx1
			LDA $1602,x
			SEC
			SBC #$02
			CMP #$02
			BCC Label12
			LSR A
			BCC Label12
			LDA $15EA,x
			TAX
			INC $0301,x
			LDX $15E9
Label12:		PLY
			CPY #$01
			BNE Label13
			JSR S_Label2
Label13:		LDA $1602,x
			CMP #$04
			BCC Return1
			LDY $157C,x
			LDA $E4,x
			CLC
			ADC X_Offset,y
			SEC
			SBC $1A
			LDY $15EA,x
			STA $0308,y
			LDA $D8,x
			SEC
			SBC $1C
			CLC
			ADC #$10
			STA $0309,y
			LDA $157C,x
			LSR A
			BCS Label14
			ORA #$40
Label14:		ORA $64
			ORA $15F6,x
			STA $030B,y
			LDA #Tile
			STA $030A,y
			TYA
			LSR A
			LSR A
			TAY
			LDA $15A0,x
			STA $0462,y
Return1:		RTS

S_Label1:		LDA $E4,x
			CLC
			ADC #$0A
			STA $00
			LDA $14E0,x
			ADC #$00
			STA $01
			LDA $D8,x
			STA $02
			LDA $14D4,x
			STA $03
			REP #$20
			LDA $94
			STA $04
			LDA $96
			STA $06
			SEP #$20
			JSR GetAngle
			LDA $00
			STA $0C
			LDA $01
			STA $0D
			LDY #$00
			LDA $7FAB10,x
			AND #$04
			BEQ Label2F
			LDY #$02
Label2F:		STY $0F
			LDA #$10
			STA $1DF9
GenLoop:		LDY #$07
Label21:		LDA $170B,y
			BEQ Label20
			DEY
			BPL Label21
			RTS

AddAngleL:		dcb $00,$20,$E0
AddAngleH:		dcb $00,$00,$FF

Label20:		LDA #$02
			STA $170B,y
			LDA $E4,x
			STA $171F,y
			LDA $14E0,x
			STA $1733,y
			LDA $D8,x
			CLC
			ADC #$0A
			STA $1715,y
			LDA $14D4,x
			ADC #$00
			STA $1729,y
			LDX $0F
			LDA #$20
			STA $0E
			LDA $0C
			CLC
			ADC AddAngleL,x
			STA $00
			LDA $0D
			ADC AddAngleH,x
			STA $01
			PHY
			JSR S_Label3
			PLY
			LDX $15E9
			LDA $00
			STA $1747,y
			LDA $01
			STA $173D,y
			DEC $0F
			BPL GenLoop
			RTS

S_Label3:		REP #$31
			LDA $00
			ADC.w #$0080
			AND.w #$01FF
			STA $02
			AND.w #$00FF
			ASL A
			TAX
			LDA $07F7DB,x
			STA $06
			LDA $00
			AND.w #$00FF
			ASL A
			TAX
			LDA $07F7DB,x
			STA $04
			SEP #$30
			LDA $0E
			STA $4202
			LDY $07
			BNE SkipCos0
			LDA $06
			STA $4203
			ASL $4216
			LDA $4217
			ADC #$00
SkipCos0:		LSR $03
			BCC NotNegCos0
			EOR #$FF
			INC A
NotNegCos0:		STA $00
			LDA $0E
			LDY $05
			BNE SkipSin0
			LDA $04
			STA $4203
			ASL $4216
			LDA $4217
			ADC #$00
SkipSin0:		LSR $01
			BCC NotNegSin0
			EOR #$FF
			INC A
NotNegSin0:		STA $01
			RTS

S_Label2:		LDA $13
			AND #$03
			ORA $186C,x
			ORA $9D
			BNE Return2
			JSL $01ACF9
			AND #$0F
			CLC
			LDY #$00
			ADC #$FC
			BPL Label40
			DEY
Label40:		CLC
			ADC $E4,x
			STA $02
			TYA
			ADC $14E0,x
			PHA
			LDA $02
			CMP $1A
			PLA
			SBC $1B
			BNE Return2
			LDA $148E
			AND #$0F
			;CLC
			;ADC #$FE
			ADC #$FD
			ADC $D8,x
			STA $00
			LDA $14D4,x
			ADC #$00
			STA $01
			JSL $0285BA
Return2:		RTS

State1:			JSR S_Label4
			STZ $1602,x
			JSL $019D5F		; SubSprGfx1
			RTS

S_Label5:		LDA $1540,x
			BNE Return5
			LDA #$02
			STA $1540,x
			DEC $1570,x
			BNE Label52
			INC $C2,x
			LDA #$10
			STA $1540,x
			PLA
			PLA
Return5:		RTS

S_Label4:		LDA $1540,x
			BNE Label50
			LDA #$04
			STA $1540,x
			INC $1570,x
			LDA $1570,x
			CMP #$09
			BNE Label51
			LDY #$24
			STY $40
Label51:		CMP #$09
			BNE Label52
			INC $C2,x
			LDA #$70
			STA $1540,x
			RTS

Label52:		LDA $15F6,x
			ASL A
			ASL A
			ASL A
			ORA #$80
			AND #$F0
			STA $01
			LDA $1570,x
			DEC A
			ASL A
			ASL A
			ASL A
			ASL A
			TAX
			STZ $00
			LDY $0681
Label53:		LDA MagiKoopaPals,x
			STA $0684,y
			INY
			INX
			INC $00
			LDA $00
			CMP #$10
			BNE Label53
			LDX $0681
			LDA #$10
			STA $0682,x
			LDA $01
			STA $0683,x
			STZ $0694,x
			TXA
			;CLC
			;ADC #$12
			ADC #$11
			STA $0681
Label50:		LDX $15E9
			RTS

State3:			JSR S_Label5
			JSL $019D5F		; SubSprGfx1
			RTS

MagiKoopaPals:		dcw $7FFF,$294A,$0000,$0404,$042A,$469F,$000A,$002A
			dcw $7FFF,$35AD,$0000,$0806,$044F,$321F,$000D,$00AD
			dcw $7FFF,$4210,$0000,$0809,$0451,$1D7F,$0050,$0110
			dcw $7FFF,$4E73,$0000,$080C,$0453,$08DF,$00B3,$0173
			dcw $7FFF,$5AD6,$0000,$080F,$0455,$049B,$0116,$01D6
			dcw $7FFF,$6739,$0000,$0812,$0458,$0457,$0179,$0239
			dcw $7FFF,$739C,$0000,$0815,$045B,$0452,$01DC,$029C
			dcw $7FFF,$7FFF,$0000,$0818,$087F,$087F,$023F,$02FF

; {Ƃ̃pbgp^[
;			dcw $7FFF,$294A,$0000,$1400,$2000,$7E92,$000A,$002A
;			dcw $7FFF,$35AD,$0000,$2400,$2C00,$722F,$000D,$00AD
;			dcw $7FFF,$4210,$0000,$3000,$3800,$65CC,$0050,$0110
;			dcw $7FFF,$4E73,$0000,$3C00,$4441,$5969,$00B3,$0173
;			dcw $7FFF,$5AD6,$0000,$4800,$50A4,$4D06,$0116,$01D6
;			dcw $7FFF,$6739,$0000,$5442,$5D07,$40A3,$0179,$0239
;			dcw $7FFF,$739C,$0000,$60A5,$696A,$3440,$01DC,$029C
;			dcw $7FFF,$7FFF,$0000,$6D08,$75CD,$2800,$023F,$02FF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubHorzPos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS	LDY #$00
		LDA $D1
		SEC
		SBC $E4,x
		STA $0F
		LDA $D2
		SBC $14E0,x
		BPL SPR_L12
		INY
SPR_L12:	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubVertPos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_VERT_POS	LDY #$00
		LDA $D3
		SEC
		SBC $D8,x
		STA $0E
		LDA $D4
		SBC $14D4,x
		BPL SPR_L11
		INY
SPR_L11		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubOffScreen
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TABLE3			dcb $40,$B0
TABLE6			dcb $01,$FF
TABLE4			dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0
TABLE5			dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0	LDA #$06
			BRA STORE_03
SUB_OFF_SCREEN_X1	LDA #$04
			BRA STORE_03
SUB_OFF_SCREEN_X2	LDA #$02
STORE_03		STA $03
			BRA START_SUB
SUB_OFF_SCREEN_X3	STZ $03

START_SUB		JSR SUB_IS_OFF_SCREEN
			BEQ RETURN_2
			LDA $5B
			AND #$01
			BNE VERTICAL_LEVEL
			LDA $D8,x
			CLC
			ADC #$50
			LDA $14D4,x
			ADC #$00
			CMP #$02
			BPL ERASE_SPRITE
			LDA $167A,x
			AND #$04
			BNE RETURN_2
			LDA $13
			AND #$01
			ORA $03
			STA $01
			TAY
			LDA $1A
			CLC
			ADC TABLE4,y
			ROL $00
			CMP $E4,x
			PHP
			LDA $1B
			LSR $00
			ADC TABLE5,y
			PLP
			SBC $14E0,x
			STA $00
			LSR $01
			BCC LABEL200
			EOR #$80
			STA $00
LABEL200		LDA $00
			BPL RETURN_2
ERASE_SPRITE		LDA #$FF
			STA $1626,x
			STA $1FD6,x
RETURN_2		RTS

VERTICAL_LEVEL		LDA $167A,x
			AND #$04
			BNE RETURN_2
			LDA $13
			LSR A
			BCS RETURN_2
			AND #$01
			STA $01
			TAY
			LDA $1C
			CLC
			ADC TABLE3,y
			ROL $00
			CMP $D8,x
			PHP
			LDA.W $001D
			LSR $00
			ADC TABLE6,y
			PLP
			SBC $14D4,x
			STA $00
			LDY $01
			BEQ LABEL22
			EOR #$80
			STA $00
LABEL22:		LDA $00
			BPL RETURN_2
			BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN	LDA $15A0,x
			ORA $186C,x
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetAngle:		REP #$20
			LDY #$00
			LDA $02
			SEC
			SBC $06
			BPL If_Plus20
			INY
			EOR.w #$FFFF
			INC A
If_Plus20:		STA $02
			LDA $00
			SEC
			SBC $04
			BPL If_Plus21
			INY
			INY
			EOR.w #$FFFF
			INC A
If_Plus21:		STA $00
			STY $04
			BEQ X_Zero
			CMP.w #$0100
			XBA
			ROR A
			XBA
			TAY
			LDA $02
			BEQ Y_Zero
			CMP.w #$0100
			XBA
			ROR A
			AND.w #$FF80
			STA $4204
			STY $4206
			LDA $4214
			LSR A
			LSR A
			LSR A
			LSR A
			CMP.w #$0100
			SEP #$20
			BCC NoOverFlow
			LDA #$FF
NoOverFlow:		TAY
			LDA AtanTable,y
			LSR $04
			BCS If_Plus30
			EOR #$FF		;\
			INC A			; | :360-
			BEQ If_Plus30		; |
			INC $01			;/
If_Plus30:		LSR $04
			BCS If_Plus31
			EOR #$FF		;\
			INC A			; | :180-
			BNE If_Plus31		; |
			INC $01			;/
If_Plus31:		STA $00
			LDA #$FE
			TRB $01
			RTS

X_Zero:			SEP #$20
			LDY #$00
			LSR $04
			BCS If_Plus32
			INY
If_Plus32:		STY $01
			LDA #$80
			STA $00
			LDY #$FF
			RTS

Y_Zero:			SEP #$20
			STZ $00
			LDY #$00
			LDA $04
			AND #$02
			BNE If_Plus33
			INY
If_Plus33:		STY $01
			LDY #$00
			RTS

AtanTable:
db $00,$05,$0A,$0F,$13,$18,$1D,$21,$25,$29,$2D,$31,$34,$37,$3A,$3D
db $40,$42,$44,$46,$49,$4A,$4C,$4E,$50,$51,$53,$54,$55,$56,$58,$59
db $5A,$5B,$5C,$5D,$5D,$5E,$5F,$60,$60,$61,$62,$62,$63,$64,$64,$65
db $65,$66,$66,$67,$67,$68,$68,$68,$69,$69,$6A,$6A,$6A,$6B,$6B,$6B
db $6C,$6C,$6C,$6C,$6D,$6D,$6D,$6D,$6E,$6E,$6E,$6E,$6F,$6F,$6F,$6F
db $6F,$70,$70,$70,$70,$70,$71,$71,$71,$71,$71,$71,$71,$72,$72,$72
db $72,$72,$72,$72,$73,$73,$73,$73,$73,$73,$73,$73,$74,$74,$74,$74
db $74,$74,$74,$74,$74,$74,$75,$75,$75,$75,$75,$75,$75,$75,$75,$75
db $75,$75,$76,$76,$76,$76,$76,$76,$76,$76,$76,$76,$76,$76,$76,$76
db $76,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77
db $77,$77,$77,$78,$78,$78,$78,$78,$78,$78,$78,$78,$78,$78,$78,$78
db $78,$78,$78,$78,$78,$78,$78,$78,$78,$78,$79,$79,$79,$79,$79,$79
db $79,$79,$79,$79,$79,$79,$79,$79,$79,$79,$79,$79,$79,$79,$79,$79
db $79,$79,$79,$79,$79,$79,$79,$79,$79,$7A,$7A,$7A,$7A,$7A,$7A,$7A
db $7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A
db $7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A,$80